// Arup Guha
// 6/29/2013
// Solution to 2012 UCF Locals Problem: Palindrome

import java.util.*;

public class palindrome {

	public static int[] sequence;
	public static int n;

	public static void main(String[] args) {

		Scanner stdin = new Scanner(System.in);
		int numCases = stdin.nextInt();

		// Go through each case.
		for (int loop=1; loop<=numCases; loop++) {

			// Get this sequence.
			n = stdin.nextInt();
			sequence = new int[n];
			for (int i=0; i<n; i++)
				sequence[i] = stdin.nextInt();

			System.out.println("Sequence #"+loop+": "+bfs());
			System.out.println();
		}
	}

	// Run a BFS to find the answer!
	public static int bfs() {

		// Set up queue.
		LinkedList<entry> q = new LinkedList<entry>();
		q.offer(new entry(0, sequence.length-1, 0));
		HashSet<Integer> used = new HashSet<Integer>();
		used.add(sequence.length-1);

		// Run BFS...we are guaranteed a distance of 100 or less, so we are okay.
		while (q.size() > 0) {

			// Get the next item and advance it.
			entry item = q.poll();
			entry adv = advance(item);

			// Hey, this item is a palindrome, so we're done!
			if (adv.start >= adv.end)
				return item.dist;

			// At this point we can make two changes.
			int item1 = adv.start*10000 + adv.end-1;
			int item2 = (adv.start+1)*10000 + adv.end;

			// ONLY add to the queue if we haven't see this state before!!!
			if (!used.contains(item1)) {
				q.offer(new entry(adv.start, adv.end-1, item.dist+1));
				used.add(item1);
			}
			if (!used.contains(item2)) {
				q.offer(new entry(adv.start+1, adv.end, item.dist+1));
				used.add(item2);
			}
		}

		// Guess we never made it. Should never get here.
		return -1;
	}

	// Advances this start,end pair to the next one that
	// exists without having to make any changes in the string.
	public static entry advance(entry cur) {

		int s = cur.start;
		int e = cur.end;

		// Characters at ends match, so advance both counters...
		while (s <= e && s < n && e >= 0 && sequence[s] == sequence[e]) {
			s++;
			e--;
		}

		return new entry(s, e, cur.dist);
	}

}

class entry {

	public int start;
	public int end;
	public int dist;

	public entry(int s, int e, int d) {
		start = s;
		end = e;
		dist = d;
	}
}