// Arup Guha
// 9/17/2013
// Solution to UCF Programming Team Lecture Problem: Prefix Prime

import java.util.*;

public class prefixcomp {
	
	public static void main(String[] args) {
		
		Scanner stdin = new Scanner(System.in);
		int numCases = stdin.nextInt();
		
		// Process cases.
		for (int loop=0; loop<numCases; loop++) {
			int n = stdin.nextInt();
			printRec(n, 0, 0);
		}
	}
	
	// Prints out all prefix primes of length n where the first k digits are
	// stored in cur. We assume cur is a valid prefix prime of length k.
	public static void printRec(int n, int cur, int k) {
		
		// By definition, this is a solution, so print.
		if (n == k)
			System.out.println(cur);
			
		else {
			
			// Update possible starting digits.
			int start = 0;
			if (k == 0) start++;
			
			// Try each digit as the next one.
			for (int digit=start; digit<10; digit++) {
				
				// We only make a recursive call if adding this digit forms a prime.
				if ((10*cur+digit)%(k+1) == 0)
					printRec(n, 10*cur+digit, k+1);
			}
		}
	}
}